/*
 * Copyright (C) 2004 Pistooli <pistooli@lindowsmail.com>
 */

#ifndef _KVISUALBOYADVANCE_H_
#define _KVISUALBOYADVANCE_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kmainwindow.h>
#include <kvisualboyadvancedlg.h>
#include <qstring.h>
#include <qpushbutton.h>
#include <qfiledialog.h>
#include <qlineedit.h>
#include <qdir.h>
#include <qlistview.h>
#include <qprocess.h>
#include <qmessagebox.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qtimer.h>
#include <qspinbox.h>

/**
 * @short Application Main Window
 * @author Pistooli <pistooli@lindowsmail.com>
 * @version 0.1
 */
class KVisualBoyAdvance : public KVisualBoyAdvanceDlg
//class KVisualBoyAdvance : public KVisualBoyAdvanceDlg
{
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    KVisualBoyAdvance();

    /**
     * Default Destructor
     */
    virtual ~KVisualBoyAdvance();
public slots:
    void initDefaults(); // initializes defaults for the program

    void showGameRoms(); // get list of games from gamePath and shows in listView Window

    void getBinaryPath(); // sets the Path for the VIsualBoyAdvance bonary - called when the GetBinatryPath Button is pushed
    void getRomPath(); // sets the Path for GBA ROMs - called when the GetRomPath Button is pushed
    void getScreenShotDir(); // gets screenshot directory
    void getSaveDir(); //
    void getBiosPath(); //sets external BIOS file ( can not be zip!!! )

    void startGame(); //start game - called when Start button pushed
    void stopGame(); // guess what... ;-)

    void setAutoFrameSkip(); // sets AutoFrameSkip OFF is Frameskip valuse changed to anything else than 0;
    void setFrameSkipValue(); // sets FrameSkip Value to 0 if Autoframeskip checked
    void setThrottleState(); // sets Trottle state to ON if Trottle value changed from 0
    void setThrottleValue(); // sets Throttle Value to 0 of Throttle state checked out

    void exitProgram(); // called when Exit button pushed
    void saveConfig(); // save VisualBoyAdvance config file in the format of VisualBoyAdvance
    void backupConfig(); // copy config file into backup for restore purposes
    void restoreConfig(); // restore config before running game...
    void readConfig(); // reads config values from Configuration files
    void showConfig(); // show config values in GUI
    void defaultConfig(); // puts configuration to default values
    void saveDefaultConfig(); // saves default configuration;


private:
    QString gamePath; // path to game ROMs

    QString binaryPath; // path to VisualBoyAdvance binary
    QString captureDir; // path to take screenshots
    QString captureFormat; // format for screenshots
    QString saveDir; // directory to save state
    QString soundQuality; // sound quality ( 2 = 22 kHz , 1 = 44 kHz, 4 = 11 kHz )
    QString soundEcho;
    QString soundLowPass;
    QString soundVolume;
    QString soundReverse;
    QString removeIntros;
    QString soundOff;

    QString saveType;
    QString flashSize;

// FINAL cut
	QString frameSkip;
	QString disableMMX;

// FINAL cut ends

    QString configVideo;
    QString configFilters;
    QString configSpeed;
    QString configAutoFrameSkip;
    QString configFrameSkipValue;
    QString configThrottle;
    QString configThrottleValue;
    QString configRTC;
    QString configYUV;
    QString configFile; // path and name of configurationfile ( VisualBoyAdsvance style
    QString configFileBackup; // backup of config file
    QString configFileOld; // old type config file
    QString useBios; //
    QString biosFile; //

    QFileDialog *getRomPathDir;
    QFileDialog *getBinaryPathDir;
    QFileDialog *getBiosFile;
    QFileDialog *dialogGetScreenShotDir;
    QFileDialog *dialogGetSaveDir;

    QProcess *proc; // process to run the emulator itslef
    QProcess *procConfigs; // process to handle copy of configuration fles

    int fakeValue;
};

#endif // _KVISUALBOYADVANCE_H_
